## fenics-dolfinx 0.10.0.post3

=== debian/changelog ===
fenics-dolfinx (1:0.10.0.post3-1exp6) experimental; urgency=medium

  * powerpc: skip test_compare_solution_linear_vs_nonlinear_problem
  * update versioned Build-Depends: python3-nanobind (>= 2.5.0~)

 -- Drew Parsons <dparsons@debian.org>  Thu, 04 Dec 2025 19:36:43 +0100

fenics-dolfinx (1:0.10.0.post3-1exp5) experimental; urgency=medium

  * update debian/tests
    - set MPLBACKEND=Agg to run python demo tests with
      matplotlib off-screen (demo_comm-pattern.py)
      Complements PYVISTA_OFF_SCREEN=True already used for pyvista tests
    - add Restrictions: allow-stderr to python tests, since some demos
      emit warnings about pyvista off-screen and pytest itself emits
      a DeprecationWarning about crc32c
  * debian patch fix_demo_half_loaded_waveguide.patch fixes filepath
    handling in python demo_half_loaded_waveguide.py

 -- Drew Parsons <dparsons@debian.org>  Wed, 26 Nov 2025 13:50:25 +0100

fenics-dolfinx (1:0.10.0.post3-1exp4) experimental; urgency=medium

  * update debian patch doc_build.patch to fix location of local
    petsc4py docs
  * debian/rules: stop treating warnings as errors during python
    (sphinx) doc build (warns that pyvista intersphinx web objects are
    not accessible)

 -- Drew Parsons <dparsons@debian.org>  Tue, 25 Nov 2025 16:30:28 +0100

fenics-dolfinx (1:0.10.0.post3-1exp3) experimental; urgency=medium

  * update debian/tests
    - control Depends: python3-networkx
      for python demo tests (demo_comm-pattern.py)
    - test-dolfinx-python-demos skip pyamg demo tests
      (pyamg is not yet packaged for debian)
    - Depends: python3-pyvista for python demo tests
  * debian patches fix_scotch_partitioner_PR4001.patch and
    fix_partitioner_ghost_PR4003.patch apply upstream PR#4001 and
    #4003 to fix handling of mesh tests using the scotch partitioner

 -- Drew Parsons <dparsons@debian.org>  Tue, 25 Nov 2025 13:16:56 +0100

fenics-dolfinx (1:0.10.0.post3-1exp2) experimental; urgency=medium

  * debian patch test_no_mumps.patch skips test_mixed_system in
    test_petsc_solver_wrappers.py for kind="nest" (or list)
    if MUMPS is not available. For kind="mpi" (or None), fall back to
    superlu_dist, or petsc direct in serial.
  * adios2 is not reliable on bigendian systems (s390x), skip
    cpp demo demo_mixed_poisson* on them

 -- Drew Parsons <dparsons@debian.org>  Mon, 24 Nov 2025 13:37:43 +0100

fenics-dolfinx (1:0.10.0.post3-1exp1) experimental; urgency=medium

  * New upstream release
  * simplify openmpi handling by setting oversubscribe option only
    through env variable PRTE_MCA_rmaps_default_mapping_policy.
    MPIEXEC_PARAMS not needed.
  * add debian/source/lintian-overrides to ignore lintian warning
    test-leaves-python-version-untested. The python dependency is
    picked up via Depends: @builddeps@, and is not relevant to cpp

 -- Drew Parsons <dparsons@debian.org>  Sun, 23 Nov 2025 18:51:00 +0100

fenics-dolfinx (1:0.10.0.post2-1exp3) experimental; urgency=medium

  * debian patch fix_test_dg0.patch fixes skip of DG-0 test on systems
    without adios2 (without VTXWriter)
  * set PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe on
    openmpi systems. Needed by s390x buildd.

 -- Drew Parsons <dparsons@debian.org>  Wed, 19 Nov 2025 14:11:18 +0100
