=== debian/changelog ===
fenics-dolfinx (1:0.10.0.post4-1exp1) experimental; urgency=medium

  * New upstream release
    - supports adios2 2.11
  * debian/tests: reenable python demo_stokes (fixed in 0.10)

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Dec 2025 01:12:14 +0100

fenics-dolfinx (1:0.9.0-13) unstable; urgency=medium

  * backport debian patch doc_build.patch from 1:0.10.0.post2-1exp1 to
    stop treating doxygen warnings as errors (in C++ docs)

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Dec 2025 00:59:43 +0100

fenics-dolfinx (1:0.9.0-12) unstable; urgency=medium

  * debian patch py314_refcount_bunkab84c39.patch applies Adrian
    Bunk's patch to enable test_mpi_comm_refcount to keep passing
    with python 3.14. Closes: #1122069

 -- Drew Parsons <dparsons@debian.org>  Tue, 09 Dec 2025 23:00:31 +0100

fenics-dolfinx (1:0.9.0-11) unstable; urgency=medium

  * debian/tests: skip demo_stokes in MPI demo tests, which fails with
    PETSc 3.24

 -- Drew Parsons <dparsons@debian.org>  Wed, 26 Nov 2025 20:31:08 +0100
